#include <stdio.h>
#include <time.h>
#include <curses.h>
#include <ncurses.h>
#include <string.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <sys/types.h>
#include "defs.h"
#include <locale.h>
    
int main(void) { 

    time_t t;  
    struct tm *tid;
    char c;
    
    WINDOW *win_reload;
    
    if (!setlocale(LC_CTYPE, "sv_SE")) {
        fprintf(stderr, "Unable to set locale to sv_SE. Lists might get fucked...\n");
    }
    printf("tvprog %s\n",VERSION); 
    printf("Loading lists...\n");
    fflush(stdout);

    reload(1); 
    init_curses();
    init_colors();
    print_border();
    halfdelay(10);
    print_all();
    
    while(1) {
        check_resize();
        t = time(NULL);
        tid = localtime(&t);
        if (tid->tm_sec == 0) {
            print_all();

            if (((tid->tm_hour)%24) == 6 && tid->tm_min == 0) { /* 06:00 AM, update! */
                reload(0);  /* not bootup */
                init_colors();
                print_border();
                print_all();
            }

            check_watches(((tid->tm_hour)%24)*60+tid->tm_min);
        }
        if ((c = getch()) != ERR) {
            /* mvprintw(20,10,"Got key %d   ",c); */          
            switch (c) {
                case 114: /* r */
                    win_reload = print_reload_win();  
                    reload(1);
                    win_reload = kill_win(win_reload);
                    init_colors();
                    print_border();
                    print_all();
                    break;
                case 113: /* q */
                    kill_curses();
                    exit(0);
                    break;
                case 119: /* w */
                    if (!win_watch) {
                        win_watch = print_watch_win();
                        print_border();
                        print_all();
                    }
                    else if (win_watch) {
                        win_watch = kill_win(win_watch);
                        print_border();
                        print_all();
                    }
                    break;
                case 116: /* t */
                    if (!win_tw) {
                        win_tw = print_todays_watch();
                        print_border();
                        print_all();
                    }
                    else if (win_tw) {
                        win_tw = kill_win(win_tw);
                        print_border();
                        print_all();
                    }
                    break;
                case 101: /* e */
                    edit_tvconf();
                    win_reload = print_reload_win();  
                    reload(1);
                    win_reload = kill_win(win_reload);
                    init_colors();
                    print_border();
                    print_all();
                    break;
                case 102: /* f */
                    if (!win_find) {
                        win_find = find_program();
                        print_border();
                        print_all();
                    }
                    else if (win_find) {
                        win_find = kill_win(win_find);
                        print_border();
                        print_all();
                    }    
                    
                    break;
               case 10: /* return */
               case 27: /* esc */
                    if (win_find) {
                        win_find = kill_win(win_find);
                        print_border();
                        print_all();
                    }
                    if (win_watch) {
                        win_watch = kill_win(win_watch);
                        print_border();
                        print_all();
                    }
                    if (win_tw) {
                        win_tw = kill_win(win_tw);
                        print_border();
                        print_all();
                    }
                    if (win_list) {
                        win_list = kill_win(win_list);
                        print_border();
                        print_all();
                    }
                    break;
               case 108: /* l */
                    if (!win_list) {
                        win_list = list_channel();
                        print_border();
                        print_all();
                    }
                    else {
                        win_list = kill_win(win_list);
                        print_border();
                        print_all();
                    }
                    break;
               
            }
        }  
    }  
}

